﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Documents.Excel;

namespace NullCharCorruption
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void ultraButton1_Click(object sender, EventArgs e)
        {
            if (saveFileDialog1.ShowDialog() == DialogResult.OK)
            {
                var workbook = new Workbook(WorkbookFormat.Excel2007);
                var worksheet = workbook.Worksheets.Add("something");
                ultraGridExcelExporter1.Export(ultraGrid1, worksheet);
                workbook.Save(saveFileDialog1.FileName);
            }
        }

        protected override void OnLoad(EventArgs e)
        {
            base.OnLoad(e);

            // Populate data
            bindingSource1.Add(new DisplayObject("something", 'a'));
            bindingSource1.Add(new DisplayObject("something else", 'b'));

            // When our object is hydrated from the database, DBNull
            // for a character is converted to a null character.
            // The reason for that is certainly questionable but 
            // beyond the scope of the real issue.
            bindingSource1.Add(new DisplayObject("something", '\0'));
        }
    }
}
